'汎用等高線図作画V31の標準ﾓｼﾞｭｰﾙ     ［作成］黒田英夫(2023/04)
Imports System.Drawing.Printing

Module ContCom
    'V21での改良点・・・.NetFrameworkの指定バージョンを3.5から4に変更
    'V22での改良点・・・入力データで節点のみの形式（要素なし）を追加、
    '                   構造の作画を追加、要素の生成を追加、要素と節点の削除を追加
    'V23での改良点・・・入力データファイルの先頭にプログラム名を追加
    '                   （データの読み違いを防止）
    'V24での改良点・・・実行形式をDebugモードからReleaseモードへ変更
    '                   （計算時間の大幅短縮）
    'V25での改良点・・・各画面でボタンを読みやすい色に改善
    'V26での改良点・・・Visual Basic 2017に変更
    'V27での改良点・・・プログラムファイルの文字コードをUTF-8に統一、
    '                   データファイルの文字コードを標準でUTF-8に変更
    '                   （従来のShift-JISもオプションで可能）
    'V28での改良点・・・ファイル入出力画面でキャンセル処理の改善
    'V29での改良点・・・データ表画面で表計算ソフトから貼り付け時に次行に0が入るのを防止
    'V30での改良点・・・入力データのファイル印刷メニューを廃止
    '                   （文字コードによる不具合のため）
    'V31での改良点・・・フリーソフト化、VB2022に移行、文字コードはUTF-8のみ採用

    Public Cr$                      'CR+LFのコード
    Public DirOpen$                 '立ち上げ時のディレクトリー名
    Public Fm$                      '入力データのファイル名
    Public NameX$                   'X軸名称
    Public NameY$                   'Y軸名称
    Public Title$                   'タイトル

    Public InOut As Integer         'ファイル入出力の種類（0:入力、1:出力）
    Public Kcolorfill As Integer    '等高線図のカラーフィルの有無（0:なし、1:有り）
    Public KdataBackup As Integer   '入力データのバックアップファイル作成（0:なし、1:有り）
    Public KdataChange As Integer   'データ変更の有無（0:なし、1:有り）
    Public KE1 As Integer           '開始要素番号
    Public KE2 As Integer           '最終要素番号
    Public KfileOK As Integer       'ﾌｧｲﾙのOK有無（0:なし、1:有り）
    Public KindData As Integer      'データ種別（0:要素・節点設定、1:節点設定のみ）
    Public KindDel As Integer       '削除の種別（0:要素、1:点）
    '    Public KindEncod As Integer     'ファイルの文字コード（0:UTF-8、1:Shif-JIS）
    Public Kindex As Integer        'ﾃｷｽﾄｱﾚｲのｲﾝﾃﾞｯｸｽ
    Public KnewUFileA As Integer    '最近使用ﾌｧｲﾙAの更新有無
    Public KnumDisp As Integer      '構造作画での番号表示（0:なし、1:有り）
    Public KnumSb As Integer        'ﾌｫﾝﾄ文字ｻｲｽﾞの操作変数
    Public KnumSize As Integer      '構造作画での番号ｻｲｽﾞ
    Public Kprinter As Integer      'ﾌﾟﾘﾝﾀｰ作画の採否（0:否、1:採用）
    Public Kscreen As Integer       '作画画面サイズ（0：全画面、1：通常画面）
    Public Ksfx As Integer          'X軸の小数点以下の桁数
    Public Ksfy As Integer          'Y軸の小数点以下の桁数
    Public MeshX As Integer         'X軸分割数
    Public MeshY As Integer         'Y軸分割数
    Public MeshZ As Integer         'Z表示分割数
    Public Ndel As Integer          '削除する要素数または点数
    Public Nelem As Integer         '要素数
    Public Npoint As Integer        '節点数

    Public Cfix As Single           'XY方向ﾋﾟｸｾﾙ差の補正係数
    Public CYfigure As Single       'Ｙ軸数値位置の調整係数
    Public EpsL As Single           '寸法判定の最小誤差
    Public EpsL2 As Single          '寸法2次式判定の最小誤差
    Public SlenMax As Single        '要素辺の最大長さ
    Public XaxisMax As Single       'Ｘ軸の最大値
    Public XaxisMin As Single       'Ｘ軸の最小値
    Public XdMax As Single          'Xデータの最大値
    Public XdMin As Single          'Xデータの最小値
    Public XlenStd As Single        'X軸長さ基準指定(-1:Y軸と同ｽｹｰﾙ、0.5～1：最大長比)
    Public Xlower As Single         '作画領域のX最小値
    Public Xupper As Single         '作画領域のX最大値
    Public XYscale As Single        '作画スケール
    Public YaxisMax As Single       'Ｙ軸の最大値
    Public YaxisMin As Single       'Ｙ軸の最小値
    Public YdMax As Single          'Yデータの最大値
    Public YdMin As Single          'Yデータの最小値
    Public Ylower As Single         '作画領域のY最小値
    Public Yupper As Single         '作画領域のY最大値
    Public ZdispMax As Single       'Z表示の最大値
    Public ZdispMin As Single       'Z表示の最小値
    Public ZdMax As Single          'Zデータの最大値
    Public ZdMin As Single          'Zデータの最小値

    Public ArrText As New ArrayList()

    Public UFileA(6) As String      '最近使用した入力ﾌｧｲﾙの保存配列

    Public KdrawElem() As Integer   '各要素の作画有無（0:なし、1:有り）
    Public Kdel() As Integer        '削除する要素番号または点番号
    Public NNelem(,) As Integer     '各要素の3節点番号

    Public X(), Y() As Single       '節点座標
    Public Xdraw(5), Ydraw(5) As Single     '色塗り多角形の座標
    Public Xmouse(), Ymouse() As Single     'ﾏｳｽ位置座標
    Public Z() As Single            '節点の変数値

    Sub AreaCalc(ByRef area As Single, ByVal x1 As Single, _
        ByVal y1 As Single, ByVal x2 As Single, ByVal y2 As Single, _
        ByVal xb As Single, ByVal yb As Single)
        '三角形の符号付き面積算出（最初の2点に対して左側は正、右側は負）
        'area･･･符号付き面積、三角形の2倍
        'x1,y1,x2,y2･･･2点の座標
        'xb,yb･･･対象点の座標
        area = x1 * y2 - y1 * x2 + x2 * yb - y2 * xb + xb * y1 - yb * x1

    End Sub

    Sub AxisCheck2D(ByRef k1 As Integer, ByRef k2 As Integer, _
    ByRef xmin As Single, ByRef xmax As Single, _
    ByRef ymin As Single, ByRef ymax As Single)
        'X、Y軸の最小・最大値のﾁｪｯｸ
        'k1,k2･･･要素の開始、終了番号
        'xmin･･･X座標最小値
        'xmax･･･X座標最大値
        'ymin･･･Y座標最小値
        'ymax･･･Y座標最大値
        Dim i, ie, ik, j As Integer
        ik = 0
        If KindData = 0 Then
            For ie = k1 To k2
                If KdrawElem(ie) > 0 Then
                    For j = 1 To 3
                        i = NNelem(ie, j)
                        If ik = 0 Then
                            ik = 1
                            xmin = X(i) : xmax = xmin
                            ymin = Y(i) : ymax = ymin
                        Else
                            If X(i) < xmin Then
                                xmin = X(i)
                            ElseIf X(i) > xmax Then
                                xmax = X(i)
                            End If
                            If Y(i) < ymin Then
                                ymin = Y(i)
                            ElseIf Y(i) > ymax Then
                                ymax = Y(i)
                            End If
                        End If
                    Next j
                End If
            Next ie
        Else
            '節点ﾁｪｯｸ
            For i = k1 To k2
                If KdrawElem(i) > 0 Then
                    If ik = 0 Then
                        ik = 1
                        xmin = X(i) : xmax = xmin
                        ymin = Y(i) : ymax = ymin
                    Else
                        If X(i) < xmin Then
                            xmin = X(i)
                        ElseIf X(i) > xmax Then
                            xmax = X(i)
                        End If
                        If Y(i) < ymin Then
                            ymin = Y(i)
                        ElseIf Y(i) > ymax Then
                            ymax = Y(i)
                        End If
                    End If
                End If
            Next i
        End If

    End Sub

    Sub CrossCheck(ByRef kc As Integer, ByVal kelem1 As Integer, _
        ByVal k1 As Integer, ByVal k2 As Integer, ByVal kb As Integer, _
        ByVal epsL As Single)
        '対象点と他要素との交差ﾁｪｯｸ
        'kc･･･交差の有無（0:なし、1:有り）
        'kelem1･･･現在要素の番号
        'k1,k2･･･辺の2点の番号
        'kb･･･対象点の番号
        'epsL･･･微小誤差
        Dim i, ic, j, j1, j2, k, kx As Integer
        Dim a1, area, b1, b2, c1 As Single
        Dim x1, x2, xb, xc, y1, y2, yb, yc As Single
        Dim kbuf(3), kaxis(2) As Integer
        Dim xbuf(3), ybuf(3) As Single

        xb = X(kb)
        yb = Y(kb)
        For k = 1 To 2
            If k = 1 Then
                kx = k1
            Else
                kx = k2
            End If
            b1 = Math.Abs(xb - X(kx))
            b2 = Math.Abs(yb - Y(kx))
            If b1 >= b2 Then
                kaxis(k) = 1
            Else
                kaxis(k) = 2
            End If
        Next k

        kc = 0
        For i = 1 To Nelem
            For j = 1 To 3
                k = NNelem(i, j)
                kbuf(j) = k
                xbuf(j) = X(k)
                ybuf(j) = Y(k)
            Next j
            ic = 0
            For j = 1 To 3
                '三角形の符号付き面積算出
                Call AreaCalc(area, X(k1), Y(k1), X(k2), Y(k2), xbuf(j), ybuf(j))
                If area > 0 Then
                    ic = 1
                    Exit For
                End If
            Next j
            If ic > 0 Then
                For k = 1 To 2
                    If k = 1 Then
                        kx = k1
                    Else
                        kx = k2
                    End If
                    a1 = yb - Y(kx)
                    b1 = X(kx) - xb
                    c1 = -a1 * X(kx) - b1 * Y(kx)
                    For j = 1 To 3
                        Select Case j
                            Case 1
                                j1 = 1 : j2 = 2
                            Case 2
                                j1 = 2 : j2 = 3
                            Case 3
                                j1 = 3 : j2 = 1
                        End Select
                        If kx <> kbuf(j1) And kx <> kbuf(j2) Then
                            xc = X(kx)
                            yc = Y(kx)
                            x1 = xbuf(j1)
                            y1 = ybuf(j1)
                            x2 = xbuf(j2)
                            y2 = ybuf(j2)

                            '2線分の交差ﾁｪｯｸ
                            Call CrossCheckS(kc, xb, yb, xc, yc, x1, y1, x2, y2)
                            If kc > 0 Then
                                Exit For
                            End If
                        End If
                    Next j
                    If kc > 0 Then
                        Exit For
                    End If
                Next k
            End If
            If kc > 0 Then
                Exit For
            End If
        Next i

    End Sub

    Sub CrossCheckS(ByRef kc As Integer, ByVal xb As Single, ByVal yb As Single, _
        ByVal xc As Single, ByVal yc As Single, ByVal x1 As Single, _
        ByVal y1 As Single, ByVal x2 As Single, ByVal y2 As Single)
        '2線分の交差ﾁｪｯｸ
        'kc･･･端点以外での交差の有無（0:なし、1:有り）
        'xb,yb,xc,yc･･･基準線分の座標
        'x1,y1,x2,y1･･･相手線分の座標
        Dim icheck As Integer
        Dim a1, a2, b1, b2, bb, cc, dd, f1, f2, xx, yy As Single

        kc = 0
        a1 = yc - yb
        b1 = -(xc - xb)
        f1 = a1 * xb + b1 * yb

        a2 = y2 - y1
        b2 = -(x2 - x1)
        f2 = a2 * x1 + b2 * y1

        bb = a1 * b2 - b1 * a2
        If bb <> 0 Then
            xx = (f1 * b2 - f2 * b1) / bb
            yy = (f2 * a1 - f1 * a2) / bb
            Call PointCheck2(icheck, x1, y1, x2, y2, xx, yy) '最初の2点との重なりをﾁｪｯｸ
            If icheck = 0 Then
                cc = (xx - xb) * (xx - xc)
                dd = (yy - yb) * (yy - yc)
                If cc < -EpsL2 And dd < -EpsL2 Then
                    cc = (xx - x1) * (xx - x2)
                    dd = (yy - y1) * (yy - y2)
                    If cc < -EpsL2 And dd < -EpsL2 Then
                        kc = 1
                    End If
                End If
            End If
        End If

    End Sub

    Sub DfileInputU(ByVal fxx$)
        '入力ﾃﾞｰﾀﾌｧｲﾙの読み込み
        'UTF-8･･･BOMなし
        'fxx$･･･入力ﾌｧｲﾙ名
        'ii･･･ﾌｧｲﾙ番号
        Dim aa$
        Dim i, j As Integer

        Dim sr As New IO.StreamReader(fxx$)
        Dim dat() As String

        aa$ = sr.ReadLine
        dat = aa.Split(",")
        If dat(0) <> "プログラム名" Then
            aa$ = "本ソフトのUTF-8データファイルとは違います！"
            MsgBox(aa$, 0, "データエラー")
            sr.Close()
            Exit Sub
        End If
        If dat(1) <> "Contour" Then
            aa$ = "データファイルが違います！"
            MsgBox(aa$, 0, "データエラー")
            sr.Close()
            Exit Sub
        End If
        aa$ = sr.ReadLine
        dat = aa.Split(",")
        KindData = dat(1)
        Title$ = sr.ReadLine

        aa$ = sr.ReadLine
        dat = aa.Split(",")
        Npoint = dat(1)
        If KindData = 0 Then
            aa$ = sr.ReadLine
            dat = aa.Split(",")
            Nelem = dat(1)
            ReDim NNelem(Nelem, 3)
        End If

        ReDim X(Npoint), Y(Npoint), Z(Npoint)

        If KindData = 0 Then
            aa$ = sr.ReadLine
            For i = 1 To Nelem
                aa$ = sr.ReadLine
                dat = aa.Split(",")
                For j = 1 To 3
                    NNelem(i, j) = dat(j)
                Next j
            Next i
        End If

        aa$ = sr.ReadLine
        For i = 1 To Npoint
            aa$ = sr.ReadLine
            dat = aa.Split(",")
            X(i) = dat(1)
            Y(i) = dat(2)
            Z(i) = dat(3)
        Next i

        sr.Close()

    End Sub

    Sub DfileOutU(ByVal fxx$)
        '入力ﾃﾞｰﾀﾌｧｲﾙへの書き出し
        'UTF-8･･･BOMなし
        'fxx$･･･入力ﾃﾞｰﾀﾌｧｲﾙ名
        Dim aa$
        Dim i, j As Integer

        Dim sw As New IO.StreamWriter(fxx$)

        aa$ = "プログラム名" + "," + "Contour"
        sw.WriteLine(aa$)
        aa$ = "データ種別" + "," + Str(KindData)
        sw.WriteLine(aa$)
        sw.WriteLine(Title$)
        aa$ = "節点数" + "," + Str(Npoint)
        sw.WriteLine(aa$)
        If KindData = 0 Then
            aa$ = "要素数" + "," + Str(Nelem)
            sw.WriteLine(aa$)
            sw.WriteLine("要素データ (要素番号､3節点番号)")
            For i = 1 To Nelem
                aa$ = Str$(i)
                For j = 1 To 3
                    aa$ = aa$ + ",   " + Str$(NNelem(i, j))
                Next j
                sw.WriteLine(aa$)
            Next i
        End If

        sw.WriteLine("節点データ（節点番号、Ｘ座標、Ｙ座標、Ｚ値）")
        For i = 1 To Npoint
            aa$ = Str$(i) + ",   " + Str$(X(i)) + ",   " + Str$(Y(i))
            aa$ = aa$ + ",   " + Str$(Z(i))
            sw.WriteLine(aa$)
        Next i
        sw.Close()
        aa$ = "データをファイルへ保存しました。"
        MsgBox(aa$, 0, "ファイル保存完了")

    End Sub

    Sub DrawFocusRect(ByRef gr As Graphics)
        'ﾌｫｰｶｽ矩形の描画
        Dim rect As Rectangle
        Dim p1, p2 As Point

        If Xmouse(1) <= Xmouse(2) Then
            p1.X = Xmouse(1)
            p2.X = Xmouse(2)
        Else
            p1.X = Xmouse(2)
            p2.X = Xmouse(1)
        End If
        If Ymouse(1) <= Ymouse(2) Then
            p1.Y = Ymouse(1)
            p2.Y = Ymouse(2)
        Else
            p1.Y = Ymouse(2)
            p2.Y = Ymouse(1)
        End If
        rect.X = p1.X
        rect.Y = p1.Y
        rect.Width = p2.X - p1.X
        rect.Height = p2.Y - p1.Y

        gr.DrawRectangle(Pens.DarkGray, rect)   '矩形の描画

    End Sub

    Sub DrawScale(ByVal dpixb As Single, ByVal dpiyb As Single, _
    ByVal xlen As Single, ByVal ylen As Single, ByVal xmin As Single, _
    ByVal xmax As Single, ByVal ymin As Single, ByVal ymax As Single)
        '作画倍率の計算
        'dpixb･･･X軸方向のdpi値
        'dpiyb･･･Y軸方向のdpi値
        'xlen･･･作画領域のX方向長さ
        'ylen･･･作画領域のY方向長さ
        'xmin･･･X座標最小値
        'xmax･･･X座標最大値
        'ymin･･･Y座標最小値
        'ymax･･･Y座標最大値
        Dim b1, b2, cx, cy As Single

        Cfix = dpiyb / dpixb
        b1 = xmax - xmin : b2 = ymax - ymin
        If Cfix < 1 Then
            If b1 <> 0 Then
                cx = xlen / b1
            End If
            If b2 <> 0 Then
                cy = ylen / b2 / Cfix
            End If
        Else
            If b1 <> 0 Then
                cx = Cfix * xlen / b1
            End If
            If b2 <> 0 Then
                cy = ylen / b2
            End If
        End If
        If b1 = 0 Then
            XYscale = cy
        ElseIf b2 = 0 Then
            XYscale = cx
        ElseIf cy < cx Then
            XYscale = cy
        Else
            XYscale = cx
        End If

    End Sub

    Sub Elem2DPrep()
        '構造図作画準備
        Dim ie As Integer
        Dim pa, qa As Single
        ReDim KdrawElem(Nelem)

        KE1 = 1
        If KindData = 0 Then
            KE2 = Nelem
        Else
            KE2 = Npoint
            ReDim KdrawElem(Npoint)
        End If
        KnumDisp = 0
        KnumSize = 8
        For ie = KE1 To KE2
            KdrawElem(ie) = 1
        Next ie

        KnumDisp = 0

        Call AxisCheck2D(1, KE2, XaxisMin, pa, YaxisMin, qa)
        'X、Y軸の最小・最大値のﾁｪｯｸ

    End Sub

    Sub ElemAdd(ByRef kh As Integer, ByRef kside(,) As Integer)
        '要素の追加
        'kh･･･追加の有無（0:なし、1:有り）
        'kside(,)･･･使用済み区分（0:未定、1:済み）
        Dim i, ic, k, k1, k2, kb, kc, kelem1, kside1 As Integer
        Dim area, b1, b2, rlen, rlen1, rlen2, x1, x2, xb, y1, y2, yb As Single
        Dim jrand(3), kbuf(3), ksbuf(3) As Integer

        kh = 0
        ic = 0
        For i = Nelem To 1 Step -1
            For k = 3 To 1 Step -1
                If kside(i, k) = 0 Then
                    ic = ic + 1
                    kelem1 = i
                    ksbuf(ic) = k
                End If
            Next k
            If ic > 0 Then
                Exit For
            End If
        Next i

        If ic = 0 Then
            Exit Sub
        ElseIf ic = 1 Then
            kside1 = ksbuf(1)
        Else
            k1 = NNelem(kelem1, ksbuf(1))
            k2 = ksbuf(1) + 1
            If k2 > 3 Then
                k2 = 1
            End If
            b1 = Math.Sqrt((X(k1) - X(k2)) ^ 2 + (Y(k1) - Y(k2)) ^ 2)
            k1 = NNelem(kelem1, ksbuf(2))
            k2 = ksbuf(2) + 1
            If k2 > 3 Then
                k2 = 1
            End If
            b2 = Math.Sqrt((X(k1) - X(k2)) ^ 2 + (Y(k1) - Y(k2)) ^ 2)
            If b1 >= b2 Then
                kside1 = ksbuf(1)
            Else
                kside1 = ksbuf(2)
            End If
        End If

        Select Case kside1
            Case 1
                k1 = 1 : k2 = 2
            Case 2
                k1 = 2 : k2 = 3
            Case 3
                k1 = 3 : k2 = 1
        End Select
        kbuf(1) = NNelem(kelem1, k2)
        kbuf(2) = NNelem(kelem1, k1)
        x1 = X(kbuf(1))
        y1 = Y(kbuf(1))
        x2 = X(kbuf(2))
        y2 = Y(kbuf(2))
        kb = 0
        For i = 1 To Npoint
            If i <> kbuf(1) And i <> kbuf(2) Then
                xb = X(i)
                yb = Y(i)
                rlen1 = Math.Sqrt((x1 - xb) ^ 2 + (y1 - yb) ^ 2)
                rlen2 = Math.Sqrt((x2 - xb) ^ 2 + (y2 - yb) ^ 2)
                If rlen1 < SlenMax And rlen2 < SlenMax Then
                    Call AreaCalc(area, x1, y1, x2, y2, xb, yb) '三角形の符号付き面積算出
                    If area > 0 Then
                        '対象点と他要素との交差ﾁｪｯｸ
                        Call CrossCheck(kc, kelem1, kbuf(1), kbuf(2), i, epsL)
                        If kc = 0 Then
                            b1 = rlen1 + rlen2
                            If kb = 0 Or b1 < rlen Then
                                kb = i
                                rlen = b1
                            End If
                        End If
                    End If
                End If
            End If
        Next i

        If kb > 0 Then
            kh = 1
            Nelem = Nelem + 1
            NNelem(Nelem, 1) = kbuf(1)
            NNelem(Nelem, 2) = kbuf(2)
            NNelem(Nelem, 3) = kb
        Else
            kside(kelem1, kside1) = -1
        End If

    End Sub

    Sub ElemGene()
        '要素の生成
        Dim kc, kh, nb As Integer

        nb = 2 * Npoint
        ReDim NNelem(nb, 3)
        Dim kside(nb, 3) As Integer

        Call StdLenSet()    '微小誤差の設定
        Call StdElemSet()   '基準要素の設定

        Do
            Call ElemAdd(kh, kside)   '要素の追加
            Call SideCheck(kc, kside)   '辺の要否ﾁｪｯｸ
            If kc = 0 Then
                Exit Do
            End If
            If Nelem = nb Then
                Exit Do
            End If
        Loop

    End Sub

    Sub ElemSearch2(ByRef k1 As Integer, ByRef k2 As Integer)
        '拡大作画する要素の探索
        '全節点が指定領域にある要素を採用、作画要素なしの場合は元のﾃﾞｰﾀを保存
        'k1,k2･･･要素の開始、終了番号
        Dim ib, ic, ie, j, kmax, kmin As Integer
        Dim b1, b2 As Single
        Dim kbuf(Nelem) As Integer
        ic = 0
        For ie = 1 To Nelem
            kbuf(ie) = KdrawElem(ie)
            If KdrawElem(ie) > 0 Then
                For j = 1 To 3
                    ib = NNelem(ie, j)
                    b1 = X(ib) - Xmouse(1)
                    b2 = X(ib) - Xmouse(2)
                    If b1 >= 0 And b2 <= 0 Then
                        b1 = Y(ib) - Ymouse(2)
                        b2 = Y(ib) - Ymouse(1)
                        If b1 >= 0 And b2 <= 0 Then
                            If j = 3 Then
                                KdrawElem(ie) = 1
                                If ic = 0 Then
                                    ic = 1
                                    kmin = ie
                                    kmax = ie
                                ElseIf ie < kmin Then
                                    kmin = ie
                                ElseIf ie > kmax Then
                                    kmax = ie
                                End If
                            End If
                        Else
                            KdrawElem(ie) = 0
                            Exit For
                        End If
                    Else
                        KdrawElem(ie) = 0
                        Exit For
                    End If
                Next j
            End If
        Next ie
        k1 = kmin
        k2 = kmax
        If k1 = 0 Then
            For ie = 1 To Nelem
                KdrawElem(ie) = kbuf(ie)
            Next ie
        End If
    End Sub

    Sub ElemSearch2P(ByRef k1 As Integer, ByRef k2 As Integer)
        '拡大作画する点の探索
        '指定領域にある点を採用、作画点なしの場合は元のﾃﾞｰﾀを保存
        'k1,k2･･･要素の開始、終了番号
        Dim ic, ie, kmax, kmin As Integer
        Dim b1, b2 As Single
        Dim kbuf(Npoint) As Integer
        ic = 0
        For ie = 1 To Npoint
            kbuf(ie) = KdrawElem(ie)
            If KdrawElem(ie) > 0 Then
                b1 = X(ie) - Xmouse(1)
                b2 = X(ie) - Xmouse(2)
                If b1 >= 0 And b2 <= 0 Then
                    b1 = Y(ie) - Ymouse(2)
                    b2 = Y(ie) - Ymouse(1)
                    If b1 >= 0 And b2 <= 0 Then
                        KdrawElem(ie) = 1
                        If ic = 0 Then
                            ic = 1
                            kmin = ie
                            kmax = ie
                        ElseIf ie < kmin Then
                            kmin = ie
                        ElseIf ie > kmax Then
                            kmax = ie
                        End If
                    Else
                        KdrawElem(ie) = 0
                    End If
                Else
                    KdrawElem(ie) = 0
                End If
            End If
        Next ie
        k1 = kmin
        k2 = kmax
        If k1 = 0 Then
            For ie = 1 To Nelem
                KdrawElem(ie) = kbuf(ie)
            Next ie
        End If
    End Sub

    Sub FileName(ByVal fxx$, ByRef fxb$)
        'ﾌｧｲﾙ名fxx$の拡張子なしの部分fxb$を取り出す
        Dim i As Integer
        i = InStr(fxx$, ".")
        If i > 0 Then
            fxb$ = Left$(fxx$, i - 1)
        Else
            fxb$ = fxx$
        End If
    End Sub


    Sub MouseCalc2()
        'ﾏｳｽ点のﾓﾃﾞﾙ座標への変換
        Dim j As Integer
        Dim xa, xb, ya, yb As Single
        For j = 1 To 2
            xa = Xmouse(j)
            ya = Ymouse(j)
            If Cfix < 1 Then
                xb = (xa - Xlower) / XYscale + XaxisMin
                yb = (Yupper - ya) / XYscale / Cfix + YaxisMin
            Else
                xb = Cfix * (xa - Xlower) / XYscale + XaxisMin
                yb = (Yupper - ya) / XYscale + YaxisMin
            End If
            Xmouse(j) = xb
            Ymouse(j) = yb
        Next j

    End Sub

    Sub NumCheck(ByRef ic As Integer, ByRef i1 As Integer, _
        ByRef i2 As Integer, ByRef j1 As Integer, _
        ByRef j2 As Integer)
        '要素辺の重なりのﾁｪｯｸ
        'ic･･･要素辺の重なり有無（0:なし、1:有り）
        'i1･･･第1の辺の一端の節点番号
        'i2･･･第1の辺の他端の節点番号
        'j1･･･第2の辺の一端の節点番号
        'j2･･･第2の辺の他端の節点番号
        ic = 0
        If i1 = j1 Then
            If i2 = j2 Then
                ic = 1
            End If
        ElseIf i1 = j2 Then
            If i2 = j1 Then
                ic = 1
            End If
        End If

    End Sub

    Sub OptFileIn()
        'ｵﾌﾟｼｮﾝ･ﾌｧｲﾙ読み込み
        Dim ftmp$

        ftmp$ = DirOpen$ + "\ContMenu.tmp"
        Try
            Dim sr As New IO.StreamReader(ftmp$)
            KdataBackup = Val(sr.ReadLine)
            Kscreen = Val(sr.ReadLine)
            sr.Close()
        Catch
            '処理不要
        End Try

    End Sub

    Sub OptFileOut()
        'ｵﾌﾟｼｮﾝ･ﾌｧｲﾙ書き出し
        Dim ftmp$

        ftmp$ = DirOpen$ + "\ContMenu.tmp"
        Dim sw As New IO.StreamWriter(ftmp$)
        sw.WriteLine(KdataBackup)
        sw.WriteLine(Kscreen)
        sw.Close()

    End Sub

    Sub PaintExe(ByRef gr As Graphics, ByVal ncount As Integer, _
        ByVal colorx As Color, ByVal kind As Integer)
        '塗りつぶし実行
        'gr･･･ｸﾞﾗﾌｨｯｸｽ･ｵﾌﾞｼﾞｪｸﾄ名
        'ncount･･･頂点数
        'colorx･･･境界および塗りつぶしの色
        'kind･･･境界作画の有無（0:なし、1:有り）
        Dim i As Integer
        Dim xydraw(ncount - 1) As Point
        Dim myBrush As New SolidBrush(colorx)

        For i = 1 To ncount
            xydraw(i - 1).X = Xdraw(i) + 0.001
            xydraw(i - 1).Y = Ydraw(i) + 0.001
        Next i
        gr.FillPolygon(myBrush, xydraw)

        If kind > 0 Then
            gr.DrawPolygon(Pens.Black, xydraw)
        End If

    End Sub

    Sub PointCheck2(ByRef icheck As Integer, ByVal x1 As Single, _
    ByVal y1 As Single, ByVal x2 As Single, ByVal y2 As Single, _
    ByVal xb As Single, ByVal yb As Single)
        '最初の2点との重なりをﾁｪｯｸ
        'icheck･･･2点との重なり有無（0:なし、1:有り）
        'x1,y1,x2,y2･･･2点の座標
        'xb,yb･･･指定点の座標
        Dim b1, b2 As Single
        icheck = 0
        b1 = Math.Abs(xb - x1)
        b2 = Math.Abs(yb - y1)
        If b1 < EpsL And b2 < EpsL Then
            icheck = 1
        Else
            b1 = Math.Abs(xb - x2)
            b2 = Math.Abs(yb - y2)
            If b1 < EpsL And b2 < EpsL Then
                icheck = 1
            End If
        End If
    End Sub

    Sub SideCheck(ByRef kc As Integer, ByRef kside(,) As Integer)
        '辺の要否ﾁｪｯｸ
        'kc･･･未使用辺の有無（0:なし、1:有り）
        'kside(,)･･･使用済み区分（0:未定、1:済み）
        Dim i, ic, ii, j, jj As Integer
        Dim kbuf(4), kkbuf(4) As Integer

        kc = 0
        For i = 1 To Nelem
            For j = 1 To 3
                kbuf(j) = NNelem(i, j)
            Next j
            kbuf(4) = kbuf(1)
            For j = 1 To 3
                ic = 0
                If kside(i, j) = 0 Then
                    kc = 1
                    For ii = 1 To Nelem
                        If ii <> i Then
                            For jj = 1 To 3
                                kkbuf(jj) = NNelem(ii, jj)
                            Next jj
                            kkbuf(4) = kkbuf(1)
                            For jj = 1 To 3
                                If kbuf(j) = kkbuf(jj + 1) And kbuf(j + 1) = kkbuf(jj) Then
                                    ic = 1
                                    kside(i, j) = -1
                                    kside(ii, jj) = -1
                                    Exit For
                                End If
                            Next jj
                            If ic > 0 Then
                                Exit For
                            End If
                        End If
                    Next ii
                End If
            Next j
        Next i

    End Sub

    Sub StdElemSet()
        '基準要素の設定
        Dim i, ic, icc, j, k As Integer
        Dim area, b0, b1, b2, b3, b4 As Single
        Dim rlen2, x1, x2, xb, xmin, y1, y2, yb, ymin As Single
        Dim kbuf(2) As Integer

        For i = 1 To Npoint
            ic = 0
            If i = 1 Then
                ic = 1
            ElseIf X(i) = xmin Then
                If Y(i) < ymin Then
                    ic = 1
                End If
            ElseIf X(i) < xmin Then
                ic = 1
            End If
            If ic > 0 Then
                kbuf(0) = i
                xmin = X(i) : ymin = Y(i)
            End If
        Next i

        For k = 1 To 2
            For i = 1 To Npoint
                icc = 0
                For j = 0 To k - 1
                    If i = kbuf(j) Then
                        icc = 1
                    End If
                Next j
                If icc = 0 Then
                    ic = 0
                    If kbuf(k) = 0 Then
                        ic = 1
                    Else
                        b1 = X(i) - xmin
                        b2 = Y(i) - ymin
                        b0 = b1 * b1 + b2 * b2
                        If b0 < rlen2 Then
                            ic = 1
                        End If
                    End If
                    If ic > 0 Then
                        If k = 2 Then
                            b1 = Y(kbuf(1)) - Y(kbuf(0))
                            b2 = X(kbuf(1)) - X(kbuf(0))
                            b3 = -b2 * X(i) + b1 * Y(i)
                            b4 = b1 * X(i) - b2 * Y(i) + b3
                            b1 = Math.Sqrt(b1 * b1 + b2 * b2)
                            b2 = Math.Abs(b4 / b1)
                            If b2 < EpsL Then
                                icc = 1
                            End If
                        End If
                        If icc = 0 Then
                            kbuf(k) = i
                            rlen2 = b0
                        End If
                    End If
                End If
            Next i
        Next k

        xb = X(kbuf(0))
        yb = Y(kbuf(0))
        x1 = X(kbuf(1))
        y1 = Y(kbuf(1))
        x2 = X(kbuf(2))
        y2 = Y(kbuf(2))
        Call AreaCalc(area, x1, y1, x2, y2, xb, yb) '三角形の符号付き面積算出
        If area < 0 Then
            k = kbuf(1)
            kbuf(1) = kbuf(2)
            kbuf(2) = k
        End If
        For k = 1 To 3
            NNelem(1, k) = kbuf(k - 1)
        Next k
        Nelem = 1

        b1 = (xb - x1) ^ 2 + (yb - y1) ^ 2
        b2 = (xb - x2) ^ 2 + (yb - y2) ^ 2
        If b2 > b1 Then
            b1 = b2
        End If
        b2 = (x1 - x2) ^ 2 + (y1 - y2) ^ 2
        If b2 > b1 Then
            b1 = b2
        End If
        SlenMax = 5 * Math.Sqrt(b1)

    End Sub

    Sub StdLenSet()
        '微小誤差の設定
        Dim b1, b2 As Single

        Call Elem2DPrep() '構造図作画準備

        Call AxisCheck2D(1, Npoint, XaxisMin, XaxisMax, YaxisMin, YaxisMax)
        'X、Y軸の最小・最大値のﾁｪｯｸ

        b1 = XaxisMax - XaxisMin
        b2 = YaxisMax - YaxisMin
        If b2 > b1 Then
            b1 = b2
        End If
        EpsL = 0.000001 * b1
        EpsL2 = EpsL * EpsL

    End Sub

    Sub TmpFileIn()
        'ﾃﾝﾎﾟﾗﾘｰ･ﾌｧｲﾙ読み込み
        Dim ftmp$

        ftmp$ = DirOpen$ + "\Contour.tmp"
        Try
            Dim sr As New IO.StreamReader(ftmp$)
            Fm$ = sr.ReadLine
            sr.Close()
        Catch
            '処理不要
        End Try

    End Sub

    Sub TmpFileOut()
        'ﾃﾝﾎﾟﾗﾘｰ･ﾌｧｲﾙ書き出し
        Dim ftmp$

        ftmp$ = DirOpen$ + "\Contour.tmp"
        Dim sw As New IO.StreamWriter(ftmp$)
        sw.WriteLine(Fm$)
        sw.Close()

    End Sub

    Sub UFileAddA()
        'UFileAの追加処理
        Dim i, ic, j As Integer
        ic = 0
        For i = 2 To 6
            If UFileA(i) = UFileA(0) Then
                For j = i - 1 To 0 Step -1
                    UFileA(j + 1) = UFileA(j)
                Next j
                ic = 1
                Exit For
            End If
        Next i
        If ic = 0 Then
            For i = 5 To 0 Step -1
                UFileA(i + 1) = UFileA(i)
            Next i
        End If
        UseFileAOut()       'ﾃﾝﾎﾟﾗﾘｰ･ﾌｧｲﾙ書き出し

    End Sub

    Sub UseFileAIn()
        'ﾃﾝﾎﾟﾗﾘｰ･ﾌｧｲﾙ読み込み
        Dim ftmp$
        Dim i As Integer

        ftmp$ = DirOpen$ + "\ContUFileA.tmp"
        Try
            Dim sr As New IO.StreamReader(ftmp$)
            i = 0
            Do Until sr.Peek = -1 'ﾌｧｲﾙ末尾まで
                i = i + 1
                UFileA(i) = sr.ReadLine
            Loop
            sr.Close()
        Catch
            '処理不要
        End Try

    End Sub

    Sub UseFileAOut()
        'ﾃﾝﾎﾟﾗﾘｰ･ﾌｧｲﾙ書き出し
        Dim ftmp$
        Dim i As Integer

        ftmp$ = DirOpen$ + "\ContUFileA.tmp"
        Dim sw As New IO.StreamWriter(ftmp$)
        For i = 1 To 6
            If UFileA(i) <> "" Then
                sw.WriteLine(UFileA(i))
            Else
                Exit For
            End If
        Next i
        sw.Close()

    End Sub

    Sub XYCalc2(ByRef xb As Single, ByRef yb As Single)
        'X,Yの作画座標計算
        'xb･･･X座標値
        'yb･･･Y座標値
        Dim b1, b2 As Single
        b1 = xb - XaxisMin
        b2 = yb - YaxisMin
        If Cfix < 1 Then
            xb = b1 * XYscale + Xlower
            yb = Yupper - b2 * XYscale * Cfix
        Else
            xb = b1 * XYscale / Cfix + Xlower
            yb = Yupper - b2 * XYscale
        End If
    End Sub

End Module
